com.mysql.cj.jdbc

## Interface ClientInfoProvider

    public interface ClientInfoProvider

Classes that implement this interface and provide a no-args constructor can be used by the driver to store and retrieve client information and/or labels. The driver will create an instance for each Connection instance, and call initialize() once and only once. When the connection is closed, destroy() will be called, and the provider is expected to clean up any resources at this time.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `destroy()` Called once by the driver when the connection this provider instance belongs to is being closed.
`Properties` `getClientInfo(Connection conn)` Returns the client info for the connection that this provider instance belongs to.
`String` `getClientInfo(Connection conn, String name)` Returns the client info for the connection that this provider instance belongs to.
`void` `initialize(Connection conn, Properties configurationProps)` Called once by the driver when it needs to configure the provider.
`void` `setClientInfo(Connection conn, Properties properties)` Sets the client info for the connection that this provider instance belongs to.
`void` `setClientInfo(Connection conn, String name, String value)` Sets the client info for the connection that this provider instance belongs to.

### Method Detail

#### initialize

    void initialize(Connection conn,
                    Properties configurationProps)
             throws SQLException

Called once by the driver when it needs to configure the provider.

Parameters:
  `conn` - the connection that the provider belongs too.
  `configurationProps` - a java.util.Properties instance that contains configuration information for the connection.
Throws:
  `SQLException` - if initialization fails.

#### destroy

    void destroy()
          throws SQLException

Called once by the driver when the connection this provider instance belongs to is being closed. Implementations are expected to clean up and resources at this point in time.

Throws:
  `SQLException` - if an error occurs.

#### getClientInfo

    Properties getClientInfo(Connection conn)
                      throws SQLException

Returns the client info for the connection that this provider instance belongs to. The connection instance is passed as an argument for convenience's sake. Providers can use the connection to communicate with the database, but it will be within the scope of any ongoing transactions, so therefore implementations should not attempt to change isolation level, autocommit settings or call rollback() or commit() on the connection.

Parameters:
  `conn` - connection object
Returns:
  client info as Properties
Throws:
  `SQLException` - if an error occurs
See Also:
  `Connection.getClientInfo()`

#### getClientInfo

    String getClientInfo(Connection conn,
                         String name)
                  throws SQLException

Returns the client info for the connection that this provider instance belongs to. The connection instance is passed as an argument for convenience's sake. Providers can use the connection to communicate with the database, but it will be within the scope of any ongoing transactions, so therefore implementations should not attempt to change isolation level, autocommit settings or call rollback() or commit() on the connection.

Parameters:
  `conn` - connection object
  `name` - property name
Returns:
  the client info by given property name
Throws:
  `SQLException` - if an error occurs
See Also:
  `Connection.getClientInfo(java.lang.String)`

#### setClientInfo

    void setClientInfo(Connection conn,
                       Properties properties)
                throws SQLClientInfoException

Sets the client info for the connection that this provider instance belongs to. The connection instance is passed as an argument for convenience's sake. Providers can use the connection to communicate with the database, but it will be within the scope of any ongoing transactions, so therefore implementations should not attempt to change isolation level, autocommit settings or call rollback() or commit() on the connection.

Parameters:
  `conn` - connection object
  `properties` - Properties object
Throws:
  `SQLClientInfoException` - if an error occurs
See Also:
  `Connection.setClientInfo(java.util.Properties)`

#### setClientInfo

    void setClientInfo(Connection conn,
                       String name,
                       String value)
                throws SQLClientInfoException

Sets the client info for the connection that this provider instance belongs to. The connection instance is passed as an argument for convenience's sake. Providers can use the connection to communicate with the database, but it will be within the scope of any ongoing transactions, so therefore implementations should not attempt to change isolation level, autocommit settings or call rollback() or commit() on the connection.

Parameters:
  `conn` - connection object
  `name` - property name
  `value` - property value
Throws:
  `SQLClientInfoException` - if an error occurs
See Also:
  `Connection.setClientInfo(java.lang.String,java.lang.String)`

Copyright © 2016, 2023, Oracle and/or its affiliates.